<template page>
  <header>
    <h1 id=logo>
      <a :href="state.token ? `/${state.token}` : '/'"><img src=https://assets.tci.anthropedia.org/images/anthropedia.svg alt="Anthropedia Foundation"></a>
    </h1>
    <section id=language :if="state.page === 'introduction'">
      <button value=en @click="switchLanguage"><img alt=English title=English src=https://upload.wikimedia.org/wikipedia/commons/a/a4/Flag_of_the_United_States.svg></button>
      <button value=fr @click="switchLanguage"><img alt=Français title=Français src=https://upload.wikimedia.org/wikipedia/commons/4/4a/Flag_of_France_%281790%E2%80%931794%29.svg></button>
      <button value=se @click="switchLanguage"><img alt=Swedish title=Swedish src=https://upload.wikimedia.org/wikipedia/commons/4/4c/Flag_of_Sweden.svg></button>
    </section>
  </header>

  <main>
    <x-introduction :if="state.page === 'introduction'" :token="state.token"></x-introduction>
    <x-test :if="state.page === 'test'" :token="state.token" :questions="state.questions"></x-test>
    <x-end :if="state.page === 'end'" :token="state.token"></x-end>
    <error-404 :if="state.page === 'error'" :error="state.error"></error-404>
  </main>

  <footer>
    ${ _('ANTHROPEDIA™ FOUNDATION is a U.S. registered 501(c)(3) tax-deductible nonprofit charity — ©2020 ANTHROPEDIA™ FOUNDATION all rights reserved.') }
  </footer>
</template>

<script>
  export default class extends Lego {
    async init() {
      this.state = {
        page: '',
        clients: [],
        clientId: null,
        user: {},
        questions: [],
      }

      page('*', (req, next) => {
        document.body.onbeforeunload = null
        next()
      })

      page('/end', () => this.render({ page: 'end' }))

      page('/:token/test', async (req) => {
        this.setState({ token: req.params.token })
        const response = await api(`/assignment/${this.state.token}/questions`)
        if (!response.ok) {
          return this.render({ page: 'error', error: "The link is invalid or outdated" })
        }
        this.render({ page: 'test', questions: response.data })
        document.body.onbeforeunload = () => confirm('You are in the middle of the test and you will have to start over. Are you sure you want to quit?')
      })

      page('/:token', async (req) => {
        this.setState({ token: req.params.token })
        const response = await api(`/assignment/${this.state.token}/questions` )
        if (!response.ok) return this.render({ page: 'error', error: "The link is invalid or outdated" })
        this.render({ page: 'introduction' })
      })

      page('*', () => {
        this.render({ page: 'error', error: 'The URL is broken, the page does not exist.' })
      })

      await this.loadLanguage()

      page({ hashbang: true })
    }

    async loadLanguage() {
      const language = localStorage.language || 'en'
      const request = await api(`/i18n/${language}/clients`)
      window.trans = request.data
    }

    async switchLanguage(event) {
      localStorage.language = event.currentTarget.value
      await this.loadLanguage()
      location.reload()
    }
  }
</script>

<style>
  header {
    padding: .1rem 1rem;
    background-color: var(--white-background);
    box-shadow: .3rem 0 .5rem rgba(0, 0, 0, .4);
    position: sticky;
    top: 0;
    z-index: 3;
  }
  #logo {
    width: 5rem;
  }
  #logo a,
  #logo img {
    display: inline-block;
    width: 100%;
  }

  footer {
    color: white;
    padding: 1rem;
    font-size: .6rem;
  }

  header {
    display: flex;
  }
  #language {
    flex: 1;
    align-self: center;
    text-align: right;
  }
  #language button {
    max-width: 2rem;
    border: 0;
    background: none;
    cursor: pointer;
  }
  #language img {
    width: 26px;
    height: 18px;
  }
</style>
